# .COPYRIGHT:   Copyright (c) 1988,2005 European Southern Observatory,
#                                               all rights reserved
# .TYPE         make file
# .NAME         $MIDASHOME/$MIDVERS/system/ftoc/makefile
# .LANGUAGE     makefile syntax
# .ENVIRONMENT  Unix Systems.
# .REMARKS
# .AUTHOR       ESO-IPG, Garching
# .VERSION 1.0  901223:
# 050308	last modif

include ../../local/default.mk

DEV_NULL=

M = ../exec

LIB = $(LIBDIR)/libos.a

OBJ0 = forif.o ftoc.o
OBJ1 = ftoc_names.o ftoc_namesc.o
OBJ2 = ftoc_log.o ftoc_logc.o
OBJ3 = ftoc_commf.o ftoc_commff.o ftoc_commap.o ftoc_commc.o
OBJ4 = for_test.o ftoc_test.o ftoc.o
OBJ18 = for_test.o ftoc_stack.o ftoc.o

# Do not remove this order
OUT = 	$(M)/forif.exe $(M)/ftoc_names.exe \
	$(M)/ftoc_vmr.exe $(M)/ftoc_test.exe \
	$(M)/ftoc_stack.exe \
	$(INC)/ftoc.h $(INC)/ftoc_comm.h $(INC)/ftoc_log.h


# DEPENDENCIES:
all: $(OUT) 

$(M)/forif.exe: $(OBJ0)
	$(LDCC) $(OBJ0) $(LIB) $(SLIB) -o $@
	$(STRIP) $@

$(M)/ftoc_names.exe: $(OBJ1)
	$(LD77_CMD) $(OBJ1) $(SLIB) -o $@
	$(STRIP) $@

$(M)/ftoc_log.exe: $(OBJ2)
	$(LD77_CMD) $(OBJ2) $(SLIB) -o $@
	$(STRIP) $@

$(M)/ftoc_comm.exe: $(INC)/ftoc_comma.h $(INC)/ftoc_commb.h ftoc_commf.o ftoc_commff.o ftoc_commc.c
	($(CC) $(CFLAGS) -DFTOC_COMMA -c ftoc_commc.c $(DEV_NULL); \
	$(CC) $(CFLAGS) -DFTOC_COMMA -c ftoc_commap.c $(DEV_NULL); \
	$(LD77_CMD) $(OBJ3) $(SLIB) -o $@ $(DEV_NULL) ) || \
	($(CC) $(CFLAGS) -DFTOC_COMMB -c ftoc_commc.c $(DEV_NULL); \
	$(CC) $(CFLAGS) -DFTOC_COMMB -c ftoc_commap.c $(DEV_NULL); \
	$(LD77_CMD) $(OBJ3) $(SLIB) -o $@ $(DEV_NULL) )

# CG. The Alpha OSF/1 creates a fake ftoc_vmr.exe and executable.
# However it gives errors when executed. Now and after the link
# It is executed and removed if error.
#
$(M)/ftoc_vmr.exe: $(OBJ12) $(M)/ftoc_names.exe
	$(LD77_CMD) ftoc_vmrf.o ftoc_vmrc.o $(SLIB) -o $@ $(DEV_NULL) && \
	$(STRIP) $@  && $@ $(DEV_NULL) || rm -f $@ ; touch $@

$(M)/ftoc_test.exe:: $(OBJ4) 
	$(LD77_CMD) $(OBJ4) $(LIB) $(SLIB) -o $@ 
	$@ 

$(M)/ftoc_stack.exe:: $(OBJ18)
	$(LD77_CMD) $(OBJ18) $(LIB) $(SLIB) -o $@ $(DEV_NULL) && \
	$(STRIP) $@ || rm -f $@; touch $@


ftoc_test.o: ftoc_test.c $(INC)/ftoc_test.h
	$(CC) $(CFLAGS) -c ftoc_test.c $(DEV_NULL) && \
	mv ftoc_test.o $@ || touch $@

ftoc_stack.o: ftoc_stack.c $(INC)/ftoc_test.h
	$(CC) $(CFLAGS) -c ftoc_stack.c $(DEV_NULL) 

ftoc_vmrc.o: ftoc_vmrc.c
	$(CC) $(CFLAGS) `$(M)/ftoc_nam` -c ftoc_vmrc.c $(DEV_NULL) || \
	touch $@

$(INC)/ftoc.h: $(M)/ftoc_params.sh
	rm -f $(INC)/ftoc.h
	cp $(INC)/`$(M)/ftoc_params` $(INC)/ftoc.h
	rm -f core

$(INC)/ftoc_comm.h: $(M)/ftoc_comm.exe
	rm -f $@
	cp $(INC)/`$(M)/ftoc_comm.exe` $@

$(INC)/ftoc_log.h: $(M)/ftoc_log.exe
	rm -f $(INC)/ftoc_log.h
	$(M)/ftoc_log.exe >$@

ftoc_logc.o: $(INC)/ftoc.h

clean_exec:
	rm -f $(OUT)
clean:
	rm -f *.o *.f
	rm -f ftoc_commc.c ftoc_logc.c ftoc_test.c ftoc_vmrc.c
	rm -f $(INC)/ftoc.h $(INC)/ftoc_comm.h $(INC)/ftoc_log.h
